#include <stdlib.h>
#include <stdio.h>
#include <memory.h>

#include <suplib/str.h>
#include <suplib/debug.h>
#include <tparam/tparam.h>
#include <tracefct/tracefct.h>

#include "gparam.h"
#include "common.h"

static TokListToken
operator[] =
{
    { "add", Add },
    { "div", Divide },
    { "eq", Equals },
    { "mul", Multiply },
    { "sub", Subtract },
};
static TokList operators = GenTokList(operator);

void
gparam(int argc, char *argv[])
{
  paramfile pf;
  char dummy[NAME_LENGTH+1];

  tf_enter("gparam");

  pf = tparamopen(NULL, argv, argc, "r");

  /* get debug flags */
  tpgetstr(pf, "debug", c.debug, NAME_LENGTH, 0);
  debug_init(c.debug);

  c.version = tpgetb(pf, "version");
  c.help = tpgetb(pf, "help");

  if (! ( c.version || c.help ))
  {
    tpgetstr(pf, "input", c.input, NAME_LENGTH, 1);
    tpgetstr(pf, "output", c.output, NAME_LENGTH, 1);

    c.operand = tpgetd( pf, "operand" );

    tpgetstr( pf, "op", dummy, NAME_LENGTH, 1 );
    if ( tokmatch( dummy, &operators ) == -1 )
	tf_die( "illegal operator: '%s'", dummy );

    c.op = (Operator) tokmatch( dummy, &operators );
  }

  paramclose(pf);
  tf_leave();
}
