module( ..., package.seeall )

fits = require('saotrace.raygen.fits' )
jitter = require('chandra.saotrace.raygen.jitter')
pi = require('math').pi

local va = require('validate.args')
local validate = va.validate

-- provide fake keyword values to allow test to complete
function fits.table:keyword( name )

   local keyword = { RA_NOM = 0, DEC_NOM = 90, ROLL_NOM = 180}

   return keyword[name]

end


setup = _G.setup

function test_dither_asol ()

   jitter.dither_asol( 'foo.data' )

   stash = require('saotrace.raygen.intrinsic').stash[1]

   assert_equal( 'jitter', stash.mod )
   assert_equal( 'file',   stash.func )
   assert_equal( pi, stash[1].optical_axis[1].angle[1] )


end

