require 'lunatest'

local config = require( 'saotrace.config' ).raygen

function test_not_exist ()

   local ok, msg = pcall( function ()
			     config.not_exist = 3
			  end
		       )

   assert_false( ok, 'set' )

   assert_match( 'unknown element', msg, "set error message" )

   local ok, msg = pcall( function ()
			     return config.not_exist
			  end
		       )

   assert_false( ok, 'get' )
   assert_match( 'unknown element', msg, "get error message" )

end

function test_tmin ()

   assert_true( pcall( function ()
			  config.time.start = 3
		       end
		    ),
		"set"
	     )

   assert_equal( 3, config.time.start )

end

function test_jitter_intersect ()

   -- check default, it should evaluate to true
   assert_true( config.jitter.tintersect, "default" )

   -- change it
   assert_true( pcall( function ()
			  config.jitter.tintersect = false
		       end
		    ),
		"set"
	     )

   -- and see if it's tracked
   assert_false( config.jitter.tintersect, "changed" )

end


lunatest.run()
