require 'lunatest'

local convert_angle = require( 'saotrace.raygen.units').convert_angle

local math = require( 'math' )

local tests = {

   arcminute = { 1, 60, 'arcminute', 'degree' },
   radian    = { 180, math.pi, 'radian', 'degree' },
   degree    = { 60, 1, 'degree', 'arcminute' },

   parcminute = { 1, '60 arcminute', nil, 'degree' },
   pradian    = { 180, math.pi .. 'radian', nil, 'degree' },
   pdegree    = { 60, '1 degree', nil, 'arcminute' },

   tarcminute = { 1, { 60, 'arcminute'}, nil, 'degree' },
   tradian    = { 180, {math.pi, 'radian'}, nil, 'degree' },
   tdegree    = { 60, {1, 'degree'}, nil, 'arcminute' },


}


for test, args in pairs( tests ) do

   local test_name = 'test_convert_' .. test

   _G[test_name] =
      function()

	 local ok, angle = convert_angle( args[2], args[3], args[4])

	 assert_true( ok, angle )
	 assert_equal( args[1], angle[1], 0.0001)
      end
end


lunatest.run()
