require('common')
local paths = require('saotrace.suplib.paths')

------------------------------------------------
-- split

dirname, basename = paths.split( 'a/b' )
ok( dirname == 'a' and basename == 'b', "paths.split: a/b" )

dirname, basename = paths.split( 'b' )
ok( dirname == nil and basename == 'b', "paths.split: b" )

dirname, basename = paths.split( '/' )
ok( dirname == "" and basename == "", "paths.split: /" )

dirname, basename = paths.split( 'a/' )
ok( dirname == "a" and basename == "", "paths.split: a/" )

dirname, basename = paths.split( '/b' )
ok( dirname == "" and basename == "b", "paths.split: /b" )

dirname, basename = paths.split( 'a/b/c' )
ok( dirname == "a/b" and basename == "c", "paths.split: a/b/c" )

dirname, basename = paths.split( 'a/b/' )
ok( dirname == "a/b" and basename == "", "paths.split: a/b/" )

------------------------------------------------
-- is_modname

ok( paths.is_modname( 'a.b.c' ), 'a.b.c' )
ok( paths.is_modname( 'a' ), 'a' )

ok( not paths.is_modname( '.c' ), '.c' )
ok( not paths.is_modname( 'a.' ), 'a.' )

ok( not paths.is_modname( 'a-b.c' ), 'a-b.c' )
ok( not paths.is_modname( 'a.b-c' ), 'a.b-c' )

------------------------------------------------
test_summary()


