module( ..., package.seeall )

local extract = require( 'saotrace.suplib.tables' ).extract

require( 'deepcompare')

function test_extract_none( )

   local exp = { a = 1, b = 2, c = 3 }

   local tbl = extract( exp )

   assert_true( deepcompare( exp, tbl ) )


end

function test_extract_keys( )

   local exp = { b = 2, c = 3 }

   local tbl = extract( { a = 1, b = 2, c = 3 }, { 'b', 'c' } )

   assert_true( deepcompare( exp, tbl ) )


end


function test_extract_map( )

   local exp = { b = 2, c = 3 }

   local tbl = extract( { d = 2, e = 3 }, nil, { b = 'd', c = 'e' } )

   assert_true( deepcompare( exp, tbl ) )

end


function test_extract_keys_map( )

   local exp = { d = 2 }

   local tbl = extract( { b = 2, c = 3 }, { 'd' } , { ['d'] = 'b', ['e'] = 'c' } )

   assert_true( deepcompare( exp, tbl ) )

end

